Hdu 4930 斗地主

  模拟题,只是想纪念下,WA到死了…… 看到好多代码都好长,其实想说不用这么暴力。

 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstring>
 4 #include <cstdlib>
 5 #include <cmath>
 6 #include <algorithm>
 7 #include <string>
 8 #include <queue>
 9 #include <stack>
10 #include <vector>
11 #include <map>
12 #include <set>
13 #include <functional>
14 #include <time.h>
15
16 using namespace std;
17
18 const int INF = 1<<30;
19 const int MAXN = 22;
20
21 char str[2][MAXN];
22 int id[256];
23 int cnt[2][MAXN];
24 int MAX[2][5];
25 int tr[2][10];
26
27 bool check() {
28     int len[2] = {strlen(str[0]), strlen(str[1])};
29     if (len[0]==0) return true;
30     memset(cnt, 0, sizeof(cnt));
31     memset(MAX, 0, sizeof(MAX));
32     memset(tr, 0, sizeof(tr));
33
34     for (int i = 0; i < 2; i++) //统计每张牌出现的数量
35         for (int j = 0; j < len[i]; j++)
36             cnt[i][id[str[i][j]]]++;
37
38     for (int k = 0; k < 2; k++) //找出最大的牌
39         for (int i = 4; i > 0; i--)
40             for (int j = 17; j > 0; j--)
41                 if (cnt[k][j]>=i) {
42                     MAX[k][i] = j;
43                     break;
44                 }
45     for (int k = 0; k < 2; k++) //3带1、2
46         for (int i = 1; i < 3; i++)
47             for (int j = 0; j < 18; j++)
48                 if (MAX[k][3]>0 && j!=MAX[k][3] && cnt[k][j]>=i)
49                     tr[k][i] = MAX[k][3];
50
51     if (len[0]<5 && MAX[0][len[0]]>0) return true; //能出完
52     if (MAX[0][4]>0&&len[0]==6) return true; //4带2
53     if ((len[0]==4&&tr[0][1]>0)||(len[0]==5&&tr[0][2]>0)) return true; //能出完+1
54     if (cnt[0][16]>0&&cnt[0][17]>0) return true; //有王炸
55     if (cnt[1][16]>0&&cnt[1][17]>0) return false; //对方有王炸
56     if (MAX[0][4]<MAX[1][4]) return false; //对方有炸弹
57
58     for (int i = 4; i > 0; i--)
59         if (MAX[0][i]>=MAX[1][i] && MAX[0][i]>0) //有大过对方的牌
60             return true;
61
62     return false;
63 }
64
65 int main() {
66     #ifdef Phantom01
67         freopen("HDU4930.txt", "r", stdin);
68     #endif //Phantom01
69
70     id[‘3‘] = 3;
71     id[‘4‘] = 4;
72     id[‘5‘] = 5;
73     id[‘6‘] = 6;
74     id[‘7‘] = 7;
75     id[‘8‘] = 8;
76     id[‘9‘] = 9;
77     id[‘T‘] = 10;
78     id[‘J‘] = 11;
79     id[‘Q‘] = 12;
80     id[‘K‘] = 13;
81     id[‘A‘] = 14;
82     id[‘2‘] = 15;
83     id[‘X‘] = 16;
84     id[‘Y‘] = 17;
85
86     int T;
87     scanf("%d", &T);
88     gets(str[0]);
89
90     while (T--) {
91         gets(str[0]);
92         gets(str[1]);
93         if (check()) puts("Yes");
94         else puts("No");
95     }
96
97     return 0;
98 }

Hdu 4930 斗地主

时间: 2024-10-12 20:31:34

Hdu 4930 斗地主的相关文章

hdu 4930 Fighting the Landlords (模拟)

Fighting the Landlords Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others) Total Submission(s): 160    Accepted Submission(s): 52 Problem Description Fighting the Landlords is a card game which has been a heat for ye

2014多校联合六(HDU 4923 HDU 4925 HDU 4927 HDU 4930)

HDU 4923 Room and Moor 题意:给出A序列  求满足题目所写的B序列  使得方差最小 思路:可以想到最后的结果中  B序列的值一定是一段一段的  那么我们可以类似贪心去搞  对于一段序列我们可以求出什么样的b值使得方差最小  即序列中1的个数除以序列长度  又因为B是单调的  可以用一个单调栈去模拟  复杂度远远小于n^2  不要被吓怕- 代码: #include<cstdio> #include<cstring> #include<algorithm&g

HDU 4930 Fighting the Landlords(扯淡模拟题)

Fighting the Landlords 大意: 斗地主....   分别给出两把手牌,肯定都合法.每张牌大小顺序是Y (i.e. colored Joker) > X (i.e. Black & White Joker) > 2 > A (Ace) > K (King) > Q (Queen) > J (Jack) > T (10) > 9 > 8 > 7 > 6 > 5 > 4 > 3. 给你8种组合:1.

HDU 4930 Fighting the Landlords(模拟)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4930 解题报告:斗地主,加了一个四张可以带两张不一样的牌,也可以带一对,判断打出一手牌之后,如果对手没有能够大过你的牌就输出Yes,或者如果你把手上的牌一次性打完也输出Yes,否则输出No,代码有280多行,表示光是敲代码就花了一个多小时,手速还是太慢. 1.首先判断手上的牌能不能一次打完 如果一次性打不完: 2.首先判断对方有没有一对王,有就输出No 3.判断对手有没有四张的牌,如果有,再判断自己

2014多校第六场 1010 || HDU 4930 Fighting the Landlords (模拟)

题目链接 题意 : 玩斗地主,出一把,只要你这一把对方要不了或者你出这一把之后手里没牌了就算你赢. 思路 : 一开始看了第一段以为要出很多次,实际上只问了第一次你能不能赢或者能不能把牌出尽. 1 #include <cstdio> 2 #include <cstring> 3 #include <iostream> 4 5 using namespace std ; 6 7 char str1[20],str2[20] ; 8 int hash1[20],hash2[2

HDU 4930 Fighting the Landlords (超级暴力+读懂题意)

题目链接:HDU 4930 Fighting the Landlords 斗地主!!.不会玩这游戏,真是苦逼.题意其他都还好,就是要注意只要第一个回合1号玩家能压制2号玩家就算赢了(突破点). 其他就分类暴力了,思路还是比较清晰的. 注意点: 1.对方炸弹,必输 2.一回合就出完牌,必胜 AC代码: #include<stdio.h> #include<string.h> int vis1[30],vis2[30]; int find(char s) { if(s=='T') re

HDU 4930 Fighting the Landlords(暴力枚举+模拟)

HDU 4930 Fighting the Landlords 题目链接 题意:就是题中那几种牌型,如果先手能一步走完,或者一步让后手无法管上,就赢 思路:先枚举出两个人所有可能的牌型的最大值,然后再去判断即可 代码: #include <cstdio> #include <cstring> #include <algorithm> using namespace std; struct Player { int rank[15]; } p1, p2; int t, h

HDU 4930 Fighting the Landlords 模拟

_(:зゝ∠)_ 4带2居然不是炸弹,, #include <algorithm> #include <cctype> #include <cassert> #include <cstdio> #include <cstring> #include <climits> #include <vector> #include<iostream> using namespace std; #define N 18 #

HDU 4930 Fighting the Landlords --多Trick,较复杂模拟

题意:两个人A和B在打牌,只有题目给出的几种牌能出若A第一次出牌B压不住或者A一次就把牌出完了,那么A赢,输出Yes,否则若A牌没出完而且被B压住了,那么A输,输出No. 解法:知道规则,看清题目,搞清有哪些Trick,就可以直接模拟搞了.详见代码: #include <iostream> #include <cstdio> #include <cstring> #include <cstdlib> #include <cmath> #inclu